//varijable za boju pozadine
var colorNum = 0;
var color1 = "#5f5fc7"; //plava
var color2 = "#c1cb29"; //žuta
var color3 = "#c95563"; //crvena
var color4 = "#4fb854"; //zelena
var color5 = "#bc6fc1"; //ljubičasta
var color6 = "#41c0be"; //tirkiz
var color7 = "#f85bc6"; //roza
var color8 = "#c78452"; //narančasta

//broj karata
var numOfCards = 0;


// gašenje zvijezda - opcionalno
	var x = document.getElementsByClassName("stars");
    for (let e of x) {e.style.display ="none";};

// karte
let card = document.getElementsByClassName("card");
let cards = [...card];

// provjera karata
const deck = document.getElementById("card-deck");

// varijabla poteza
let moves = 0;
let counter = document.querySelector(".moves");

 // zvijezde
const stars = document.querySelectorAll(".fa-star");

// varijabla uparenih karata
let matchedCard = document.getElementsByClassName("match");

 // zvijezde
 let starsList = document.querySelectorAll(".stars li");

 // zatvaranje ikona
 let closeicon = document.querySelector(".close");

 // popup
 let modal = document.getElementById("popup1")

 // otvorene karte
var openedCards = [];


// mijesanje karata
function shuffle(array) {
    var currentIndex = array.length, temporaryValue, randomIndex;

    while (currentIndex !== 0) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }

    return array;
};



document.body.onload = startGame();


// start
function startGame(){
	
	//podesavanje css-a za sliku i overlay
	var x = document.getElementsByClassName("picture");
	for (let e of x) {e.style.height = "92%"; e.style.width = "92%";}
	document.getElementById("popup1").style.backgroundColor = "rgba(0, 0, 0, 0)";
	
	//brojanje parova
	var x = document.getElementsByClassName("card");
    for (let e of x) {numOfCards ++;}
	if(numOfCards == 9){numOfCards = 8};
 
    // praznjenje varijable otvorenih karata
    openedCards = [];

    // mijesanje karata
    cards = shuffle(cards);
    // micanje klasa s karata
    for (var i = 0; i < cards.length; i++){
        deck.innerHTML = "";
        [].forEach.call(cards, function(item) {
            deck.appendChild(item);
        });
        cards[i].classList.remove("show", "open", "match", "disabled");
    }
    // reset poteza
    moves = 0;
    counter.innerHTML = moves;
    // reset ocjene
    for (var i= 0; i < stars.length; i++){
        stars[i].style.color = "#FFD700";
        stars[i].style.visibility = "visible";
    }
    //reset timera
    second = 0;
    minute = 0; 
    hour = 0;
    var timer = document.querySelector(".timer");
    timer.innerHTML = 'minuta: <span class="moves">0</span> sekundi: <span class="moves">0</span>';
    clearInterval(interval);

}


// klasa za prikaz karata
var displayCard = function (){
    this.classList.toggle("open");
    this.classList.toggle("show");
    this.classList.toggle("disabled");
};


// dodavanje karata na listu i provjera parova
function cardOpen() {
    openedCards.push(this);
    var len = openedCards.length;
    if(len === 2){
        moveCounter();
         if(openedCards[0].getAttribute("type") === openedCards[1].getAttribute("type")){
            matched();
        } else {
            unmatched();
        }
    }
};


// podudaranje karata
function matched(){
	colorNum ++;
    openedCards[0].classList.add("match", "disabled");
    openedCards[1].classList.add("match", "disabled");
    //openedCards[0].classList.remove("show", "open", "no-event");
    //openedCards[1].classList.remove("show", "open", "no-event");
    openedCards[0].classList.add("color" + colorNum);
    openedCards[1].classList.add("color" + colorNum);
		

    		var x = openedCards[0].getElementsByClassName("indikator");
            for (let e of x) {e.innerHTML = "&nbsp"+ (matchedCard.length/2) + "&nbsp"; e.style.display="block"; e.style.borderColor = eval("color" + colorNum); e.style.color = eval("color" + colorNum);}

    		var x = openedCards[1].getElementsByClassName("indikator");
            for (let e of x) {e.innerHTML = "&nbsp"+ (matchedCard.length/2) + "&nbsp"; e.style.display="block"; e.style.borderColor = eval("color" + colorNum); e.style.color = eval("color" + colorNum);}				
	

	

    openedCards = [];
}


// nepodudaranje karata
function unmatched(){
    openedCards[0].classList.add("unmatched");
    openedCards[1].classList.add("unmatched");
    disable();
    setTimeout(function(){
        openedCards[0].classList.remove("show", "open", "no-event","unmatched");
        openedCards[1].classList.remove("show", "open", "no-event","unmatched");
        enable();
        openedCards = [];
    },1100);
}


// privremeno onemogućavanje karata
function disable(){
    Array.prototype.filter.call(cards, function(card){
        card.classList.add('disabled');
    });
}


// omogućavanje karata i onemogućavanje uparenih karata
function enable(){
    Array.prototype.filter.call(cards, function(card){
        card.classList.remove('disabled');
        for(var i = 0; i < matchedCard.length; i++){
            matchedCard[i].classList.add("disabled");
        }
    });
}


// brojanje poteza
function moveCounter(){
    moves++;
    counter.innerHTML = moves;
    //startanje timera
    if(moves == 1){
        second = 0;
        minute = 0; 
        hour = 0;
        startTimer();
    }
    // ocjena
    if (moves > 8 && moves < 12){
        for( i= 0; i < 3; i++){
            if(i > 1){
                stars[i].style.visibility = "collapse";
            }
        }
    }
    else if (moves > 13){
        for( i= 0; i < 3; i++){
            if(i > 0){
                stars[i].style.visibility = "collapse";
            }
        }
    }
}


// timer
var second = 0, minute = 0; hour = 0;
var timer = document.querySelector(".timer");
var interval;
function startTimer(){
    interval = setInterval(function(){
        timer.innerHTML = " minuta: " + '<span class="moves">' + minute + "</span>" + " sekundi: " + '<span class="moves">' + second + "</span>";
        second++;
        if(second == 60){
            minute++;
            second=0;
        }
        if(minute == 60){
            hour++;
            minute = 0;
        }
    },1000);
}


// feedback
function congratulations(){
    if (matchedCard.length == numOfCards){
        clearInterval(interval);
        finalTime = timer.innerHTML;

		setTimeout(function(){
			modal.classList.add("show");
			
			//preuređivanje HTMLa
			document.getElementById("playAgain").style.display="none";
			document.getElementById("popup1").style.display="none";
			
			var x = document.getElementsByClassName("score-panel");
	        for (let e of x) {e.innerHTML ='<div id ="popup1" class="popup"><button id ="playAgain1" class="playAgain" onclick="playAgain()">Eccellente! Gioca di nuovo.</br>Izvrsno! Igraj ponovo.</button></div>';}
			
			document.getElementById("popup1").style.margin="-20px auto";
			document.getElementById("popup1").style.width="100%";

						
			}, 2000);


        var starRating = document.querySelector(".stars").innerHTML;


        document.getElementById("finalMove").innerHTML = moves;
        document.getElementById("starRating").innerHTML = starRating;
        document.getElementById("totalTime").innerHTML = finalTime;


        closeModal();
    };
}


// ikona zatvaranja
function closeModal(){
    closeicon.addEventListener("click", function(e){
        modal.classList.remove("show");
        startGame();
    });
}


// igraj ponovo
function playAgain(){
    /*modal.classList.remove("show");
    startGame();*/
	this.location.reload();
}


// dodavanje event listenera
for (var i = 0; i < cards.length; i++){
    card = cards[i];
    card.addEventListener("click", displayCard);
    card.addEventListener("click", cardOpen);
    card.addEventListener("click",congratulations);
};
const klasa = GetParameter("para");
document.body.className = klasa;
function GetParameter(parameterName) {
    var result = null,
        tmp = [];
    var items = location.search.substr(1).split("&");
    for (var index = 0; index < items.length; index++) {
        tmp = items[index].split("=");
        if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
    }
    return result;
}